# CiviCRM v5.x.0: Publish a release candidate

## Prerequisites

See [Prerequisites](any-prereq.md)

All commands need to run in a suitably configured environment.

## 1: Sanity checks

* Note the original branch, such as `master`.
* Note the intended version, such as `5.1` or `5.3`. (In the rest of this document, we'll refer to `5.X`, but `5.X` should be adjusted to circumstance.)
* In Jenkins, review the scheduled tests for `master` and determine if anything should block the RC.
    * https://test.civicrm.org/job/CiviCRM-Core-Matrix/
    * https://test.civicrm.org/job/CiviCRM-Ext-Matrix/
    * https://test.civicrm.org/job/CiviCRM-E2E-Matrix/
    * https://test.civicrm.org/job/CiviCRM-D8-Matrix/

## 2: Update versions and create branches

We will raise the version numbers and create branches on each CiviCRM repository.
The script `givi wf:rc` performs the necessary updates:

```bash
cd ~/src/master
givi wf:rc
```

> TIP: `givi` can provide a preview (`--dry-run` aka `-N`) or an interactive confirmation (`--step` aka `-S`).

## 3: Setup automated processes

* Go to https://test.civicrm.org/job/CiviCRM-Core-Matrix/configure
    * In the list of `CIVIVER`s, remove any old RC's. Add the current RC. (ex: `4.6 5.X master`)
* Go to https://test.civicrm.org/job/CiviCRM-Core-Matrix-Timing/configure
    * In the list of `CIVIVER`s, remove any old RC's. Add the current RC. (ex: `4.6 5.X master`)
* Go to https://test.civicrm.org/job/CiviCRM-Core-Edge/configure
    * In the list of `CIVIVER`s, remove any old RC's. Add the current RC. (ex: `4.6 5.X master`)
* Go to https://test.civicrm.org/job/CiviCRM-E2E-Edge/configure
    * In the list of `CIVIVER`s, remove any old RC's. Add the current RC. (ex: `4.6 5.X master`)
* Go to https://test.civicrm.org/job/CiviCRM-Ext-Matrix/configure
    * In the list of `CIVIVER`s, remove any old RC's. Add the current RC. (ex: `4.6 5.X master`)
* Go to https://test.civicrm.org/job/CiviCRM-E2E-Matrix/configure
    * In the list of `CIVIVER`s, remove any old RC's. Add the current RC. (ex: `4.6 5.X master`)
* Go to https://test.civicrm.org/job/CiviCRM-D8-Matrix/configure
    * In the list of `CIVIVER`s, remove any old RC's. Add the current RC. (ex: `4.6 5.X master`)
* Go to https://test.civicrm.org/job/CiviCRM-Publish-Schedule/configure
    * In the list of `branchNames`, remove any old RC's. Add the current RC. (ex: `master 4.6 5.X`)
   
## 4: Publish tarballs

* Go to https://test.civicrm.org/job/CiviCRM-Publish/
* Check to see if the new branch is being built automatically. If not:
    * Login (if you haven't already)
    * Click "Build with parameters"
    * For the branch name, enter your chosen `5.X`.
